//+------------------------------------------------------------------+
//|                                                 iSmoothLines.mq5 |
//|                                       Copyright 2012-2015, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2012-2015, Lizar"
#property link        "https://login.mql5.com/ru/users/Lizar"
#property version     "1.5"
#property description "Smooth lines for iCustomChart"
/*------------------------------------------------------------------+/
.
1.      
   LibCustomChart      
     iCustomChart,    
     .  
2.        
     iCustomChart.   
    ,       
   ,  ,     .
    ,        
    ,   .   
   
:
1.    Library for Custom Chart.ex5    
   terminal_data_folder\MQL5\Libraries
2.       LibCustomChart.mqh  
      terminal_data_folder\MQL5\Include
3.         
   SmoothAlgorithms.mqh     
   terminal_data_folder\MQL5\Include
4.    iSmoothLines.mq5     
   terminal_data_folder\MQL5\Indicators
5.  iSmoothLines.mq5  MetaEditor   ( F7)
6.  iSmoothLines.ex5      , 
      ,      
   iCustomChart.
7.       :
   -      iCustomChart  
         ;
   -       iSmoothLines,  
        iCustomChart   
          . 
:
1.  LibCustomChart:
   http://www.mql5.com/ru/market/product/196
2.      :
   http://p.mql5.com/data/18/869/LibCustomChart.mqh
3.  iCustomChart:
   http://www.mql5.com/ru/market/product/203
4.   iCustomChart:
   http://www.mql5.com/ru/market/product/186
5.        
   SmoothAlgorithms.mqh:
   http://p.mql5.com/data/18/869/SmoothAlgorithms.mqh
/+------------------------------------------------------------------*/
//---      LibCustomChart:
#include <LibCustomChart.mqh>
//---     :
//#include <SmoothAlgorithms.mqh> 
#include <SmoothAlgorithms.mqh>
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
//---     
#property indicator_chart_window 
//---       2 
#property indicator_buffers 2
//---    
#property indicator_plots   1
//---       
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  SlateBlue, Magenta
//---     
double ExtIndicatorBuffer[];
double ExtColorBuffer[];
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
input Smooth_Method MA_SMethod=MODE_LWMA; //  
input int MA_Length=30;                   //                      
input int MA_Phase=100;                   //  
                                          //  JJMA    -100 ... +100,
//  VIDIA   CMO,  AMA    
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA ind;
//---
int StartBars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---    
   StartBars=ind.GetStartBars(MA_SMethod,MA_Length,MA_Phase)+1;
//---       
   ind.XMALengthCheck("Length", MA_Length);
   ind.XMAPhaseCheck ("Phase", MA_Phase, MA_SMethod);
//---      
   SetIndexBuffer(0,ExtIndicatorBuffer,INDICATOR_DATA);
//---     ,     
   SetIndexBuffer(1,ExtColorBuffer,INDICATOR_COLOR_INDEX);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---         
   string short_name=EnumToString(MA_SMethod)+"("+(string)MA_Length+","+(string)MA_Phase+")";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//---    iCustomChart     :
   return(!CustomChartInit());
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---        
//     : 
   if(!CustomChartRefresh()) return (0);
//---       
//          :
   if(CustomChartBars()<StartBars) return(0);
//---      
//---     
   if(!CustomChartSync(ExtIndicatorBuffer))  return (prev_calculated);
   if(!CustomChartSync(ExtColorBuffer))      return (prev_calculated);
//---    
   int      first;                  //      
   int      bar;                    //      
   int      custom_begin;           //      
   int      custom_prev_calculated; //    ,    
   double   custom_price[1];        //       
//---        
//---  :
   custom_begin=CustomChartBegin();
   custom_prev_calculated=rates_total-CustomChartNewBar();
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=custom_begin) //      
     {
      //---   
      custom_prev_calculated=0;
      //---      
      first=custom_begin;
      //---     
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,custom_begin+StartBars);
     }
   else  first=custom_prev_calculated-1; //      
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---
      static double custom_price_prev=0.0;
      //---   Close        :
      if(CopyClose(rates_total-1-bar,1,custom_price)!=1) custom_price[0]=EMPTY_VALUE;
      //if(CopyAsk(rates_total-1-bar,1,custom_price)!=1) custom_price[0]=EMPTY_VALUE;      
      //if(CopyBid(rates_total-1-bar,1,custom_price)!=1) custom_price[0]=EMPTY_VALUE;      
      //if(CopyLast(rates_total-1-bar,1,custom_price)!=1) custom_price[0]=EMPTY_VALUE;      
      if(custom_price[0]==EMPTY_VALUE) custom_price[0]=custom_price_prev;
      else custom_price_prev=custom_price[0];
      //---   XMASeries:
      ExtIndicatorBuffer[bar]=ind.XMASeries(custom_begin,custom_prev_calculated,rates_total,MA_SMethod,MA_Phase,MA_Length,custom_price[0],bar,false);
      //---        :
      if(bar<=custom_begin+StartBars) continue;
      if(ExtIndicatorBuffer[bar-1]<ExtIndicatorBuffer[bar]) ExtColorBuffer[bar]=0.0;
      else  ExtColorBuffer[bar]=1.0;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
